#! /usr/bin/perl

#####
#
# KJVRunVerse.pl
# MDJ 2022/04/11
#
# Given:
#   Book Abbreviation
#   Chapter Number
#   Verse Number
# Returns:
#   Running Verse Number
#
# To Run:
#   KJVRunVerse.pl
#
# ** WARNING **
# When saving perl scripts in
# Textpad, you should use
# the "Save As" command and
# change the Line Ending Box
# to "UNIX".
#
# Otherwise, you may get:
# /usr/bin/perl^M No such file
#   ( ^M = \r\n ).
#
#####

# Pre-setup
use 5.30.0;

# Perl's Database Interface Module
use DBI;

# Data Source Name
my $dsn = "dbi:mysql:dbname=KJVData";

# mysql Username
my $user = "mdavidjohnson";

# mysql Password
#my $password = 'intentionallyObfuscated';

# mysql Attributes
my %attr = (RaiseError => 1, PrintError => 0);

# Open the Database Connection
my $dbh = DBI->connect($dsn, $user, $password, \%attr)
  or die "failed to connect to MySQL database:DBI->errstr()";
  
print "\nStarting KJVRunVerse Run\n\n";

# Declare variables
my($bkAbbrev) = "";   # Book Abbreviation
my($chapNum) = "";    # Chapter Number
my($versNum) = "";    # Verse Number
my($runVersNum) = ""; # Running Verse Number

# Get the inputs and convert as required

print "Enter the Book Abbreviation: ";
$bkAbbrev = <STDIN>;
# Truncate to remove "\n"
chomp($bkAbbrev);
# Convert to all uppercase
$bkAbbrev = uc($bkAbbrev);

print "Enter the Chapter Number: ";
$chapNum = <STDIN>;
# Truncate to remove "\n"
chomp($chapNum);
# Convert to numeric
$chapNum = 0 + $chapNum;

print "Enter the Verse Number: ";
$versNum = <STDIN>;
# Truncate to remove "\n"
chomp($versNum);
# Convert to numeric
$versNum = 0 + $versNum;

# Call the function
$runVersNum = &findRunVerseNum
  ($bkAbbrev, $chapNum, $versNum);

# Display the result
print "\n";
print "Book Abbreviation    = ".$bkAbbrev."\n";
print "Chapter Number       = ".$chapNum."\n";
print "Verse Number         = ".$versNum."\n";
print "Running Verse Number = ".$runVersNum."\n";

print "\nKJVRunVerse Run Finished\n\n";

# Close the Database Connection
$dbh->disconnect;
  
exit;

sub findRunVerseNum
{
	# $bkA = Book Abbreviation
	# $chN = Chapter Number
	# $vsN = Verse Number
	# $RVN = Running Verse Number
	
	my($bkA, $chN, $vsN) = @_;
	
	# Prepare the SELECT Query
	my $sth = $dbh->prepare 
	("SELECT RunVerseNum 
	  FROM  verseList
	  WHERE BookAbbrev = '$bkA'
	  AND   ChapterNum = '$chN'
	  AND   VerseNum   = '$vsN'")
	or die "prepare statement failed: $dbh->errstr()";
	  
	# Execute the SELECT query
	$sth->execute();
	
	# Get the result of the query
	my($RVN) = $sth->fetchrow_array();
	
	# Complete the query
	$sth->finish();

	return $RVN;
}

#####
#
# EOF
#
#####


